Uses of Annotation Interface
io.helidon.config.metadata.ConfiguredOption
Packages that use ConfiguredOption
Package
Description
General utilities that use
Config.Utilities for PKI configuration and loading of certificates and keys.
Health check support for helidon SE.
Classes needed for OCI to connect to service API.
Integration with OCI Vault REST API including the KMS encryption and digest support.
Defines the Helidon metrics API so Helidon metrics-capable components can implement metrics simply and without regard for
whether metrics is actually on the runtime path or not or is enabled or not.
API and minimal implementation for metrics support service.
Security
Attribute based access control (ABAC) security provider.
Common classes for provider implementation.
Vault operation backed by configuration.
Basic security provider, supporting "basic" and "digest" authentication schemes with role support.
Integration with Open ID Connect providers.
Open ID Connect (OIDC) classes usable from all OIDC related components.
General utilities for security modules.
Support types for REST services.
Distributed tracing support for Helidon.
Helidon integration with Jaeger tracer.
Reactive web server API.
-
Uses of ConfiguredOption in io.helidon.common.configurable
Methods in io.helidon.common.configurable with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionLruCache.Builder.capacity(int capacity) Configure capacity of the cache.ScheduledThreadPoolSupplier.Builder.corePoolSize(int corePoolSize) Core pool size of the thread pool executor.ThreadPoolSupplier.Builder.corePoolSize(int corePoolSize) Core pool size of the thread pool executor.static ResourceLoad resource from binary content.ScheduledThreadPoolSupplier.Builder.daemon(boolean daemon) Is daemon of the thread pool executor.ThreadPoolSupplier.Builder.daemon(boolean daemon) Is daemon of the thread pool executor.ThreadPoolSupplier.Builder.keepAliveMinutes(int keepAliveMinutes) Keep alive minutes of the thread pool executor.ThreadPoolSupplier.Builder.maxPoolSize(int maxPoolSize) Max pool size of the thread pool executor.ScheduledThreadPoolSupplier.Builder.prestart(boolean prestart) Whether to prestart core threads in this thread pool executor.ThreadPoolSupplier.Builder.prestart(boolean prestart) Whether to prestart core threads in this thread pool executor.ThreadPoolSupplier.Builder.queueCapacity(int queueCapacity) Queue capacity of the thread pool executor.ScheduledThreadPoolSupplier.Builder.threadNamePrefix(String threadNamePrefix) Name prefix for threads in this thread pool executor.ThreadPoolSupplier.Builder.threadNamePrefix(String threadNamePrefix) Name prefix for threads in this thread pool executor.ThreadPoolSupplier.Builder.virtualEnforced(boolean enforceVirtualThreads) When configured totrue, virtual thread executor service must be available, otherwise the built executor would fail to start.ThreadPoolSupplier.Builder.virtualIfAvailable(boolean useVirtualThreads) When configured totrue, an unbounded virtual executor service (project Loom) will be used if available. -
Uses of ConfiguredOption in io.helidon.common.pki
Methods in io.helidon.common.pki with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionAlias of X.509 certificate of public key.Load certificate chain from PEM resource.KeyConfig.KeystoreBuilder.certChainAlias(String alias) Alias of an X.509 chain.Read a private key from PEM format from a resource definition.Alias of the private key in the keystore.KeyConfig.KeystoreBuilder.keyPassphrase(String privateKeyPassphrase) Pass-phrase of the key in the keystore (used for private keys).KeyConfig.PemBuilder.keyPassphrase(String passphrase) Passphrase for private key.Keystore resource definition.KeyConfig.KeystoreBuilder.keystorePassphrase(String keystorePassword) Pass-phrase of the keystore (supported with JKS and PKCS12 keystores).KeyConfig.KeystoreBuilder.keystoreType(String keystoreType) Set type of keystore.KeyConfig.KeystoreBuilder.trustStore()If you want to build a trust store, call this method to add all certificates present in the keystore to certificate list.KeyConfig.Builder.updateWith(KeyConfig.KeystoreBuilder builder) Update this builder with information from a keystore builder.KeyConfig.Builder.updateWith(KeyConfig.PemBuilder builder) Update this builder with information from a pem builder. -
Uses of ConfiguredOption in io.helidon.health
Methods in io.helidon.health with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionHealthSupport.Builder.addExcluded(Collection<String> names) Add health checks to a black list.HealthSupport.Builder.addExcludedClass(Class<?> aClass) A class may be excluded from invoking health checks on it.HealthSupport.Builder.addIncluded(Collection<String> names) Add health checks to a white list (in caseHealthSupport.includeAllis set tofalse.HealthSupport.Builder.enabled(boolean enabled) HealthSupport can be disabled by invoking this method.Configure overall timeout of health check call. -
Uses of ConfiguredOption in io.helidon.integrations.oci.connect
Methods in io.helidon.integrations.oci.connect with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionOciConfigProfile.Builder.keyFingerprint(String keyFingerprint) Key fingerprint.OciConfigProfile.Builder.privateKey(String privateKey) PEM encoded private key.OCI region.OciConfigProfile.Builder.tenancyOcid(String tenancyOcid) Tenancy OCID.User OCID. -
Uses of ConfiguredOption in io.helidon.integrations.oci.vault
Methods in io.helidon.integrations.oci.vault with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionstatic OciVaultSecurityProviderCreate a new instance from configuration.OciVaultRx.Builder.secretApiVersion(String apiVersion) Configure API version to use.Secret OCID.OciVaultSecurityProvider.OciVaultSecretConfig.Builder.stage(SecretStage stage) Secret stage.OciVaultSecurityProvider.OciVaultSecretConfig.Builder.versionName(String versionName) Secret version name.OciVaultSecurityProvider.OciVaultSecretConfig.Builder.versionNumber(Integer versionNumber) Secret version number. -
Uses of ConfiguredOption in io.helidon.metrics.api
Methods in io.helidon.metrics.api with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionMetricsSettings.Builder.appTagValue(String appTag) Sets the value for the_apptag to be applied to all metrics.MetricsSettings.Builder.baseMetricsSettings(BaseMetricsSettings.Builder baseMetricsSettingsBuilder) Set the base metrics settings.BaseMetricsSettings.Builder.enableBaseMetric(String dottedName, boolean value) Sets whether a specific base metric should be enabled.BaseMetricsSettings.Builder.enabled(boolean value) Sets whether base metrics should be enabled.ComponentMetricsSettings.Builder.enabled(boolean value) Sets whether metrics should be enabled for the component.MetricsSettings.Builder.enabled(boolean value) Sets whether metrics should be enabled.RegistrySettings.Builder.enabled(boolean value) Sets whether the metric type should be enabled.Sets the regex for names to exclude.KeyPerformanceIndicatorMetricsSettings.Builder.extended(boolean value) Sets whether exntended KPI metrics should be enabled in the settings.RegistrySettings.Builder.filterSettings(RegistryFilterSettings.Builder registryFilterSettingsBuilder) Sets the filter to use for identifying specific metrics to enable.MetricsSettings.Builder.globalTags(Map<String, String> globalTags) Sets the global tags to be applied to all metrics.Sets the refex for names to include.MetricsSettings.Builder.keyPerformanceIndicatorSettings(KeyPerformanceIndicatorMetricsSettings.Builder kpiSettings) Set the KPI metrics settings.KeyPerformanceIndicatorMetricsSettings.Builder.longRunningRequestThresholdMs(long value) Sets the long-running request threshold (in ms).MetricsSettings.Builder.registrySettings(MetricRegistry.Type registryType, RegistrySettings registrySettings) Sets the registry settings for the specified registry type. -
Uses of ConfiguredOption in io.helidon.metrics.serviceapi
Methods in io.helidon.metrics.serviceapi with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionMetricsSupport.Builder.restServiceSettings(RestServiceSettings.Builder restServiceSettingsBuilder) Set the REST service settings. -
Uses of ConfiguredOption in io.helidon.security
Methods in io.helidon.security with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionSecurity.Builder.addProvider(SecurityProvider provider) Add a provider, works asSecurity.Builder.addProvider(SecurityProvider, String), where the name is set toClass.getSimpleName().Security.Builder.authenticationProvider(AuthenticationProvider provider) Set the default authentication provider.Security.Builder.authorizationProvider(AuthorizationProvider provider) Set the default authorization provider.Security.Builder.enabled(boolean enabled) Security can be disabled using configuration, or explicitly.Security.Builder.executorService(Supplier<ExecutorService> supplier) Configure executor service to be used for blocking operations within security.Security.Builder.serverTime(SecurityTime time) Server time to use when evaluating security policies that depend on time.SecurityTime.Builder.shiftBySeconds(long seconds) Configure a time-shift in seconds, to move the current time to past or future.Override current time zone.Security.Builder.tracingEnabled(boolean tracingEnabled) Whether or not tracing should be enabled. -
Uses of ConfiguredOption in io.helidon.security.providers.abac
Methods in io.helidon.security.providers.abac with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionAbacProvider.Builder.failIfNoneValidated(boolean failIfNoneValidated) Whether to fail if NONE of the attributes is validated.AbacProvider.Builder.failOnUnvalidated(boolean failOnUnvalidated) Whether to fail if any attribute is left unvalidated. -
Uses of ConfiguredOption in io.helidon.security.providers.common
Methods in io.helidon.security.providers.common with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionAdd supported host for this target.Add supported method for this target.Add supported paths for this target.OutboundConfig.Builder.addTarget(OutboundTarget config) Add a new target configuration.OutboundTarget.Builder.addTransport(String transport) Add supported transports for this target.Configure the name of this outbound target. -
Uses of ConfiguredOption in io.helidon.security.providers.config.vault
Methods in io.helidon.security.providers.config.vault with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionCreate a new secret from a value.ConfigVaultProvider.Builder.masterPassword(char[] masterPassword) Configure master password used for encryption/decryption. -
Uses of ConfiguredOption in io.helidon.security.providers.httpauth
Methods in io.helidon.security.providers.httpauth with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionHttpBasicAuthProvider.Builder.optional(boolean optional) Whether authentication is required.Set the realm to use when challenging users.HttpBasicAuthProvider.Builder.subjectType(SubjectType subjectType) Principal type this provider extracts (and also propagates).HttpBasicAuthProvider.Builder.userStore(SecureUserStore store) Set user store to validate users. -
Uses of ConfiguredOption in io.helidon.security.providers.oidc
Methods in io.helidon.security.providers.oidc with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionOidcProvider.Builder.oidcConfig(OidcConfig config) Configuration of OIDC (Open ID Connect).OidcProvider.Builder.optional(boolean optional) Whether authentication is required.OidcProvider.Builder.outboundConfig(OutboundConfig config) Configuration of outbound rules.OidcProvider.Builder.propagate(boolean propagate) Whether to propagate identity.OidcProvider.Builder.useJwtGroups(boolean useJwtGroups) Claimgroupsfrom JWT will be used to automatically add groups to current subject (may be used withRolesAllowedannotation). -
Uses of ConfiguredOption in io.helidon.security.providers.oidc.common
Methods in io.helidon.security.providers.oidc.common with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionAudience of issued tokens.OidcConfig.Builder.authorizationEndpointUri(URI uri) URI of an authorization endpoint used to redirect users to for logging-in.OidcConfig.Builder.baseScopes(String scopes) Configure base scopes.Client ID as generated by OIDC server.OidcConfig.Builder.clientSecret(String clientSecret) Client secret as generated by OIDC server.OidcConfig.Builder.clientTimeout(Duration duration) Timeout of calls using web client.OidcConfig.Builder.cookieDomain(String domain) Domain the cookie is valid for.OidcConfig.Builder.cookieHttpOnly(Boolean httpOnly) When using cookie, if set to true, the HttpOnly attribute will be configured.OidcConfig.Builder.cookieMaxAgeSeconds(long age) When using cookie, used to set MaxAge attribute of the cookie, defining how long the cookie is valid.OidcConfig.Builder.cookieName(String cookieName) Name of the cookie to use.OidcConfig.Builder.cookiePath(String path) Path the cookie is valid for.OidcConfig.Builder.cookieSameSite(SetCookie.SameSite sameSite) When using cookie, used to set the SameSite cookie value.OidcConfig.Builder.cookieSecure(Boolean secure) When using cookie, if set to true, the Secure attribute will be configured.OidcConfig.Builder.frontendUri(String uri) Full URI of this application that is visible from user browser.OidcConfig.Builder.headerTokenHandler(TokenHandler tokenHandler) ATokenHandlerto process header containing a JWT.OidcConfig.Builder.identityUri(URI uri) URI of the identity server, base used to retrieve OIDC metadata.OidcConfig.Builder.introspectEndpointUri(URI uri) Endpoint to use to validate JWT.Issuer of issued tokens.OidcConfig.Builder.maxRedirects(int maxRedirects) Configure maximal number of redirects when redirecting to an OIDC provider within a single authentication attempt.OidcConfig.Builder.oidcMetadata(Resource resource) Resource configuration for OIDC Metadata containing endpoints to various identity services, as well as information about the identity server.OidcConfig.Builder.oidcMetadataWellKnown(Boolean useWellKnown) If set to true, metadata will be loaded from default (well known) location, unless it is explicitly defined using oidc-metadata-resource.Name of a query parameter that contains the JWT token when parameter is used.Proxy host to use.OidcConfig.Builder.proxyPort(int proxyPort) Proxy port.OidcConfig.Builder.proxyProtocol(String protocol) Proxy protocol to use when proxy is used.OidcConfig.Builder.redirect(boolean redirect) By default the client should redirect to the identity server for the user to log in.OidcConfig.Builder.redirectAttemptParam(String paramName) Configure the parameter used to store the number of attempts in redirect.OidcConfig.Builder.redirectUri(String redirectUri) URI to register web server component on, used by the OIDC server to redirect authorization requests to after a user logs in or approves scopes.OidcConfig.Builder.scopeAudience(String audience) Audience of the scope required by this application.OidcConfig.Builder.serverType(String type) Configure one of the supported types of identity servers.A resource pointing to JWK with public keys of signing certificates used to validate JWT.OidcConfig.Builder.tokenEndpointAuthentication(OidcConfig.ClientAuthentication tokenEndpointAuthentication) Type of authentication to use when invoking the token endpoint.OidcConfig.Builder.tokenEndpointUri(URI uri) URI of a token endpoint used to obtain a JWT based on the authentication code.Whether to use cookie to store JWT between requests.Whether to expect JWT in a header field.Whether to use a query parameter to send JWT token from application to this server.OidcConfig.Builder.validateJwtWithJwk(Boolean useJwk) Use JWK (a set of keys to validate signatures of JWT) to validate tokens. -
Uses of ConfiguredOption in io.helidon.security.util
Methods in io.helidon.security.util with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionTokenHandler.Builder.tokenFormat(String format) Token format for creating outbound tokens.TokenHandler.Builder.tokenHeader(String header) Set the name of header to look into to extract the token.TokenHandler.Builder.tokenPattern(Pattern pattern) Set the token pattern (Regular expression) to extract the token.TokenHandler.Builder.tokenPrefix(String prefix) Set the prefix of header value to extract the token. -
Uses of ConfiguredOption in io.helidon.servicecommon.rest
Methods in io.helidon.servicecommon.rest with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionRestServiceSettings.Builder.crossOriginConfig(CrossOriginConfig.Builder crossOriginConfigBuilder) Sets the cross-origin config builder for use in establishing CORS support for the service endpoints.Sets the routing name to use for setting up the service's endpoint.RestServiceSettings.Builder.webContext(String webContext) Sets the web context to use for the service's endpoint. -
Uses of ConfiguredOption in io.helidon.tracing
Methods in io.helidon.tracing with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionTracerBuilder.addTracerTag(String key, boolean value) Tracer level tags that get added to all reported spans.TracerBuilder.addTracerTag(String key, Number value) Tracer level tags that get added to all reported spans.TracerBuilder.addTracerTag(String key, String value) Tracer level tags that get added to all reported spans.TracerBuilder.collectorHost(String host) Host to use to connect to tracing collector.TracerBuilder.collectorPath(String path) Path on the collector host to use when sending data to tracing collector.TracerBuilder.collectorPort(int port) Port to use to connect to tracing collector.TracerBuilder.collectorProtocol(String protocol) Protocol to use (such ashttporhttps) to connect to tracing collector.TracerBuilder.enabled(boolean enabled) When enabled, tracing will be sent.TracerBuilder.registerGlobal(boolean global) When enabled, the created instance is also registered as a global tracer.TracerBuilder.serviceName(String name) Service name of the traced service. -
Uses of ConfiguredOption in io.helidon.tracing.jaeger
Methods in io.helidon.tracing.jaeger with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionJaegerTracerBuilder.addPropagation(io.jaegertracing.Configuration.Propagation propagation) Add propagation type to use.JaegerTracerBuilder.logSpans(boolean logSpans) Whether the reporter should also log the spans.Authentication token sent as a "Bearer" to the endpoint. -
Uses of ConfiguredOption in io.helidon.webserver
Methods in io.helidon.webserver with annotations of type ConfiguredOptionModifier and TypeMethodDescriptionWebServer.Builder.addSocket(SocketConfiguration config) Adds an additional named server socket configuration.WebServerTls.Builder.allowedCipherSuite(List<String> cipherSuite) Set allowed cipher suite.SocketConfiguration.SocketConfigurationBuilder.backlog(int backlog) Configures a maximum length of the queue of incoming connections on the server socket.default BSocketConfiguration.SocketConfigurationBuilder.bindAddress(String address) Configures local address where the server listens on with the server socket.WebServerTls.Builder.clientAuth(ClientAuthentication clientAuth) Configures whether client authentication will be required or not.SocketConfiguration.SocketConfigurationBuilder.enableCompression(boolean value) Enable negotiation for gzip/deflate content encodings.WebServerTls.Builder.enabled(boolean enabled) Whether the TLS config should be enabled or not.default BA helper method that just callsSocketConfiguration.SocketConfigurationBuilder.bindAddress(String).SocketConfiguration.SocketConfigurationBuilder.maxHeaderSize(int size) Maximal number of bytes of all header values combined.SocketConfiguration.SocketConfigurationBuilder.maxInitialLineLength(int length) Maximal number of characters in the initial HTTP line.SocketConfiguration.SocketConfigurationBuilder.maxPayloadSize(long size) Set a maximum payload size for a client request.Configure a socket name, to bind named routings to.SocketConfiguration.SocketConfigurationBuilder.port(int port) Configures a server port to listen on with the server socket.WebServer.Builder.printFeatureDetails(boolean shouldPrint) Set totrueto print detailed feature information on startup.WebServerTls.Builder.privateKey(KeyConfig privateKeyConfig) Configure private key to use for SSL context.SocketConfiguration.SocketConfigurationBuilder.receiveBufferSize(int receiveBufferSize) Configures proposed value of the TCP receive window that is advertised to the remote peer on the server socket.WebServerTls.Builder.sessionCacheSize(long sessionCacheSize) Set the size of the cache used for storing SSL session objects.WebServerTls.Builder.sessionTimeoutSeconds(long sessionTimeout) Set the timeout for the cached SSL session objects, in seconds.Configures a server socket timeout.SocketConfiguration.SocketConfigurationBuilder.tls(WebServerTls webServerTls) Configures SSL for this socket.Set the trust key configuration to be used to validate certificates.WebServer.Builder.workersCount(int workers) Sets a count of threads in pool used to process HTTP requests.